"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var redux_data_service_1 = require("redux-data-service");
var Model_1 = require("../Model");
var faker_1 = require("faker");
var react_1 = require("@storybook/react");
var addon_actions_1 = require("@storybook/addon-actions");
var ModelForm_1 = require("./ModelForm");
var ModelField_1 = require("./ModelField");
var ModelFormFakeModel = (function (_super) {
    __extends(ModelFormFakeModel, _super);
    function ModelFormFakeModel() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.serviceName = "modelFormFakeModel";
        return _this;
    }
    __decorate([
        redux_data_service_1.attr(redux_data_service_1.StringField),
        __metadata("design:type", String)
    ], ModelFormFakeModel.prototype, "fullText", void 0);
    __decorate([
        redux_data_service_1.attr(redux_data_service_1.BooleanField),
        __metadata("design:type", Boolean)
    ], ModelFormFakeModel.prototype, "checkbox", void 0);
    return ModelFormFakeModel;
}(redux_data_service_1.Model));
var ModelFormFakeModelService = (function (_super) {
    __extends(ModelFormFakeModelService, _super);
    function ModelFormFakeModelService() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.name = "modelFormFakeModel";
        _this.ModelClass = ModelFormFakeModel;
        return _this;
    }
    return ModelFormFakeModelService;
}(redux_data_service_1.DataService));
function createMockModelFormFakeModel(id) {
    return new ModelFormFakeModel({
        id: faker_1.random.number().toString(),
        fullText: faker_1.lorem.word(),
        checkbox: false
    });
}
var fakeModel;
var Input;
var FormCheckbox;
Input = function () { return React.createElement("input", null); };
FormCheckbox = function () { return React.createElement("input", { type: "checkbox", checked: true }); };
react_1.storiesOf("ModelForm", module)
    .addDecorator(function (story) {
    redux_data_service_1.initializeTestServices({
        modelFormFakeModel: {
            ModelFormFakeModel: ModelFormFakeModel,
            ModelFormFakeModelService: ModelFormFakeModelService,
            createMockModelFormFakeModel: createMockModelFormFakeModel
        }
    });
    fakeModel = redux_data_service_1.seedService("modelFormFakeModel");
    return story();
})
    .add("Default", function () { return (React.createElement(Model_1.Model, { modelName: "modelFormFakeModel", id: fakeModel.id }, function (_a) {
    var model = _a.model;
    return (React.createElement(ModelForm_1.ModelForm, { model: model, onSave: addon_actions_1.action("model saved!") },
        React.createElement(ModelField_1.ModelField, { name: "fullText", label: "FirstName", component: Input })));
})); })
    .add("With checkbox", function () { return (React.createElement(Model_1.Model, { modelName: "modelFormFakeModel", id: fakeModel.id }, function (_a) {
    var model = _a.model;
    return (React.createElement("div", { style: { padding: "20px" } },
        React.createElement(ModelForm_1.ModelForm, { model: model },
            React.createElement(ModelField_1.ModelField, { name: "id", component: Input, label: "ID" }),
            React.createElement(ModelField_1.ModelField, { name: "checkbox", component: FormCheckbox, checkboxLabel: "Checkbox" }))));
})); })
    .add("Disabled - default", function () { return (React.createElement(Model_1.Model, { modelName: "modelFormFakeModel", id: fakeModel.id }, function (_a) {
    var model = _a.model;
    return (React.createElement(ModelForm_1.ModelForm, { model: model, readOnly: true },
        React.createElement(ModelField_1.ModelField, { name: "fullText", label: "First Name" })));
})); })
    .add("Disabled - optional", function () {
    var Component = function (_a) {
        var value = _a.value;
        return (React.createElement("div", null, value));
    };
    return (React.createElement(Model_1.Model, { modelName: "modelFormFakeModel", id: fakeModel.id }, function (_a) {
        var model = _a.model;
        return (React.createElement(ModelForm_1.ModelForm, { model: model, readOnly: true },
            React.createElement(ModelField_1.ModelField, { name: "fullText", label: "First Name", readOnlyComponent: Component })));
    }));
});
